1000  REM *** QWATCH Analog Watch for SMSQ/E
1010  REM ***  Wolfgang Uhlig 1994 - 2004
1020  REM *** High Colour       ; 26-01-04
1030  REM >>> Revision 206c bsjr; 17-03-12
1040  REM >>> Revision 206d bsjr; 24-01-13, added SMSQmulator
1050  REM >>> Revision 207a bsjr; 02.07.18, fixed Q68 resolutions
1060  ::
1070 :rem:-main
1080  INIT_QWA : MAIN_QWA : STOP
1090  ::
1100  DEF PROC INIT_QWA
1110  REM >>>203 +: 24.03.10; sep proc; >206:..20.02.12;
1120   smde%= DISP_TYPE : REM >201; get mode !SMSQ
1130   sysm%= MACHINE   : REM >206; get hware
1140   REM >206; 10/13=S/GC 28=QXL 30=QPC 20=SQm 17=Q40 18=Q68 2/8,16,24=ATR
1150  :
1160   SELect ON smde%
1170    =16,32,33        : REM *** used colours - all WM-colours!!
1180     bgcol   = 41296 : REM *** background [45526] >201; darker
1190     white   = 65535
1200     clockcol= 64527 : REM *** outer circle
1210     handscol= 65472
1220     quartcol= 47083 : REM *** dots on circle [36832] >201; lighter and sec.hand
1230    = REMAINDER
1240     smde%   = 0     : REM >203; flag for Wman type, NB! must be SMSQ
1250     bgcol   = 0     : REM *** background
1260     white   = 7
1270     clockcol= 4     : REM *** outer circle
1280     handscol= 4
1290     quartcol= 2     : REM *** dots on the outer circle
1300   END SELect
1310  :
1320   REM *** Here size, pos & backgr colour of the clock can be determined
1330   REM *** Warning: another window size will change the clock size, too
1340   REM >201 +: 22.10.09; fixed offset to wndo size, rgt.top
1350   JOB_NAME 'QWATCH'                   : REM >205;
1360   OPEN #1,'con_': xpf%= 10: ypf%= 10  : REM >206; x/ypos
1370   width%= SCR_XLIM: height%= SCR_YLIM : REM >201; get size, ! no need for EP4
1380   REM >201; date txt =11 chrs (66px), so can use smaller wndo
1390   xsz%   = 72            : REM *** width of clock wndo >201; 82 ->72
1400   ysz%   = 78            : REM *** height of clock wndo >201; 100 ->78
1410   xstart%= width% -xsz%  : REM *** x-org clock wndo, upper right of scr
1420   cx= 34: cy= 44 :cr= 36 : REM >201; x 30->34, y 47->44, r 30->36, NB def scale 100
1430   angle  = 0             : REM >206; ??? =6.25 (2 *pi =6.28, idem 0!)
1440   min%= 1: rfh%= 5       : REM >206; circle =1, 5 min =0, 1 min =2, +refresh
1450   dfmt%  = 0             : REM >202; date 0=eur, 1=US
1460   xof%= 10: yof%= 8      : REM >206; offsets Arcs
1470  :
1480   REM *** excentricity and angle of circles depend on screen resolution
1490   REM >206; ! 0.74 = more accurate on larger circle (200px) on 28,30
1500   REM >206d; +SMSQmulator(20)
1510   IF sysm% =18 : SELect ON height% =384,768 : sysm%= 30 : REM >207; Q68
1520   SELect ON sysm%
1530    =20,28,30 : exc= .78          : REM >206; QXL,QPC (.8 ->.78) >206d;
1540    =17,18 : exc= 1.12            : REM >207; Qx0/Q68
1550     ysz%= ysz% *.84              : REM >207; adj height
1560     cx= cx *1.2: cy= cy *.94     : REM >207; adj center
1570     cr= cr *.94: xof%= 13: yof%= 8 : REM >207; adj radius, arc
1580    =10 TO 13 : rfh%= 15          : REM >206; S/GC
1590     SELect ON smde%
1600      =16 : exc= .58              : REM >206; AUR
1610       ysz%= ysz% *1.32           : REM >206; adj height, rad clock
1620       cx= cx *.74: xof%= 7: yof%= 7
1630      =0,5 : exc= 1               : REM >206; m4/8, 5=AUR undocumented!
1640       IF width% >512 : exc= .78  : REM >206; hires
1650     END SELect
1660    =REMAINDER : exc= 1: rfh%= 15 : REM >206; ratio rest, refresh 5/15/60
1670   END SELect
1680  END DEF INIT_QWA
1690  ::
1700  DEF PROC MAIN_QWA
1710  REM *** Now main program
1720  REM >>>203 +: 24.03.10; sep proc; >206:.21.02.12;
1730   REPeat main
1740    firsttime= 1
1750    BEGIN_QWA xof%,yof% : REM >206;
1760    REPeat clockloop
1770     SHOW_QWA
1780     QMINUTES
1790     sec_ergebnis= SEQONDS : REM >>> draw secs, get keypress
1800     SELect ON sec_ergebnis
1810      =1  : EXIT main      : REM *** if ESC is pressed, quit program
1820      =-1 : NEXT clockloop : REM *** each refresh draw anew >202; at 5s >206; 15s
1830     END SELect
1840     IF firsttime= 1 : firsttime= 0
1850    END REPeat clockloop
1860   END REPeat main
1870   CLOSE #1
1880  END DEF MAIN_QWA
1890  ::
1900  DEF PROC BEGIN_QWA (xf,yf)
1910  REM >>>203 +: 24.03.10; set vars to init; >206:.20.02.12; +Arc
1920  LOCal i%,j%
1930   WINDOW #1,xsz%,ysz%,xstart% -xpf%,ypf%            : REM >201; x/yof
1940   IF smde% : WM_PAPER #1,bgcol: ELSE PAPER #1;bgcol : REM >203; m4
1950   DIM c%(1,2): ark= PI/3                            : REM >206; coords for arc
1960   j%= 0: FOR i%= 0,1,2 : c%(0,j%)= cx +i% *xf +xf: j%= j% +1
1970   j%= 0: FOR i%= 10,20,30 : c%(1,j%)= cy -i% -yf: j%= j% +1
1980  END DEF BEGIN_QWA
1990  ::
2000  DEF PROC SHOW_QWA
2010  REM >>>201 +: 22.10.09; add m4,fmt; >202:.24.03.10; chk day;
2020  REM >>>204 +: 12.04.10; chg min%; >206:.20.02.12;
2030   IF smde% : WM_INK #1,white: ELSE INK #1;white : REM >203; m4
2040   CLS #1: CURSOR #1;3,2
2050   datum$= DATE$: dag%= datum$(10 TO 11)
2060   IF firsttime : QWA_DAY$ dfmt%,datum$ : REM >202; 0=eur, 1=US
2070   :
2080   REM *** now draw circles
2090   REM *** first origin of the hands, colour is still white
2100    CIRCLE #1,cx,cy,1
2110   REM *** now draw rest clock
2120    IF smde% : WM_INK #1,clockcol: ELSE INK #1;clockcol : REM >203; m4
2130    SELect ON min%
2140     =0 : REM >206; 5 minute dots no circle
2150      SHOWDOTS 30,1,quartcol
2160     =1 : REM >204; 15 minute dots + circle
2170      REM *** excentricity/angle must fit scr resolution
2180      CIRCLE #1,cx,cy,cr,exc,angle
2190      ARC #1;c%(0,0),c%(1,0) to c%(0,1),c%(1,1), -ark to c%(0,2),c%(1,2),ark
2200      REM >206; make circle into 'Q'
2210      SHOWDOTS 90,1,quartcol
2220     =2 : REM >204; 1 minute dots no circle
2230      SHOWDOTS 6,.7,quartcol
2240      SHOWDOTS 30,1.2,bgcol
2250    END SELect
2260  END DEF SHOW_QWA
2270  ::
2280  DEF PROC SHOWDOTS  (st%,rd,col)
2290  REM >>>206 N: 21.02.12; sep proc;
2300  REM *** draw the dots; >201; +5 min; >206; +1 min
2310    IF smde% : WM_INK #1,col: ELSE INK #1,col : REM >203; m4
2320    FOR nd =0 TO 360 STEP st%
2330     REM *** take step 90/30/6 if you want to have dots every 15/5/1 minutes
2340     x1= cx +exc *SIN(RAD(nd)) *cr
2350     y1= cy +COS(RAD(nd)) *cr
2360     FILL #1,1
2370     CIRCLE #1,x1,y1,rd
2380     FILL #1,0
2390    END FOR nd
2400  END DEF SHOWDOTS
2410  ::
2420  DEF FN SEQONDS
2430  REM >>>202 +: 24.03.10; upd hands, day; >206:.21.02.12; +F1
2440   IF smde% : WM_INK #1,quartcol: ELSE INK #1,quartcol : REM >203; m4
2450   REPeat schl
2460    dat$= DATE$: sec= dat$(19 TO 20)
2470    OVER #1,-1 : REM >>> delete hand before redraw
2480     LINE #1,cx,cy TO cx +exc *SIN(RAD(sec *6)) *cr, cy +COS(RAD(sec *6)) *cr
2490     a%= CODE(INKEY$(#1,50))
2500     LINE #1,cx,cy TO cx +exc *SIN(RAD(sec *6)) *cr, cy +COS(RAD(sec *6)) *cr
2510    OVER #1,0
2520    IF a% =27 : RETurn 1                   : REM >>> ESC
2530    IF a% =236 : RETurn -1                 : REM >202; F2=force refresh
2540    IF a% =232
2550     min%= min% +1: IF min% >2 : min%= 0   :
2560     RETurn -1                             : REM >206; F1=change dots/circle
2570    END IF
2580    IF NOT ((sec +1) MOD rfh%): RETurn -1  : REM >202>206; refresh at 5s/15s
2590   END REPeat schl
2600  END DEF SEQONDS
2610  ::
2620  DEF PROC QMINUTES
2630  REM >>>202 +: 24.03.10; chk day; >206:..16.03.12;
2640  LOCal m%,n%,h%
2650   dat$= DATE$
2660   IF dag% <>dat$(10 TO 11): QWA_DAY$ dfmt%,dat$ : REM >202; ! a new day
2670   m%= dat$(16 TO 17) : REM >>> get mins
2680   h%= dat$(13 TO 14) : REM >>> get hours
2690   IF smde% : WM_INK #1,bgcol: ELSE INK #1;bgcol : REM >203; m4
2700   REM >>> delete old hands before new
2710   IF NOT firsttime
2720    n%= m% -1
2730    LINE #1,cx,cy TO cx +exc *SIN(RAD(n% *6)) *cr, cy +COS(RAD(n% *6)) *cr
2740    LINE #1,cx,cy TO cx +exc *SIN(RAD(h% *30 +n% *6 /12)) *2 *cr /3, cy +COS(RAD(h% *30 +n% *6 /12)) *2 *cr /3
2750   END IF
2760   IF smde% : WM_INK #1,handscol: ELSE INK #1;handscol : REM >203; m4
2770   LINE #1,cx,cy TO cx +exc *SIN(RAD(m% *6)) *cr, cy +COS(RAD(m% *6)) *cr
2780   LINE #1,cx,cy TO cx +exc *SIN(RAD(h% *30 +m% *6 /12)) *2 *cr /3, cy +COS(RAD(h% *30 +m% *6 /12)) *2 *cr /3
2790  END DEF QMINUTES
2800  ::
2810  DEF PROC QWA_DAY$ (f%,d$)
2820  REM >>>202 N: 24.03.10; sep proc
2830  LOCal fmt%: fmt%= f%
2840   SELect ON fmt%
2850    =0 : PRINT #1,d$(10 TO 11) &' ' &d$(6 TO 8) &' ' &d$(1 TO 4) : REM *** Euro format
2860    =1 : PRINT #1,d$(6 TO 8) &' ' &d$(10 TO 11) &' ' &d$(1 TO 4) : REM *** US format
2870   END SELect
2880   dag%= d$(10 TO 11)
2890  END DEF QWA_DAY$
2900 ::
